/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of PeerfactSim.KOM.
 * 
 * PeerfactSim.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tud.kom.p2psim.impl.topology.movement.modularosm.attraction;

import de.tudarmstadt.maki.simonstrator.api.Event;
import de.tudarmstadt.maki.simonstrator.api.EventHandler;

/**
 * Implementation of the interface {@link AttractionGenerator}.
 * 

 * @author Julian Zobel
 * @version 1.0, April 2019
 */
public class ConfigDynamicAttractionGenerator extends AbstractAttractionProvider {

	//private LinkedList<TemporalAttractionPoint> temporalAttractionPoints = new LinkedList<>();
		
	public void setAttractionPoint(AttractionPoint ap) {
		addAttractionPoint(ap);
	}
	
	public void setTemporalAttractionPoint(TemporalAttractionPoint ap) {
		//temporalAttractionPoints.add(ap);
		if(ap.getPlacementTime() == 0) {
			placeAP(ap);
		}
		else {
			Event.scheduleWithDelay(ap.getPlacementTime(), new EventHandler() {
				@Override
				public void eventOccurred(Object content, int type) {
					placeAP(ap);
				}
			}, null, 0);
		}
		
	}
	
	void placeAP(TemporalAttractionPoint ap) {
		addAttractionPoint(ap);		
		
		Event.scheduleWithDelay(ap.getRemovalTime(), new EventHandler() {
			@Override
			public void eventOccurred(Object content, int type) {
				removeAttractionPoint(ap);
			}
		}, null, 0);
	}


	
}
